config/routes.rb
Rails.application.routes.draw do

  root to: 'events#index'

  resources :events,       only: [:index, :show, :update]
  resources :meta_events,  only: [:index, :new, :create, :edit, :update]
  resources :room_prices,  only: [:index, :new, :create, :edit, :update] # fixme - update?
  resources :rooms,        only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,        only: [:index, :new, :create, :show, :edit, :update]
  resources :musicians,    only: [:index, :new, :create, :show, :edit, :update]

end

app/models/room.rb
class Room < ActiveRecord::Base
  has_many :reservations
  has_many :room_prizes
  validates :name, presence: true
  validates_uniqueness_of :name
end

app/controllers/rooms_controller.rb
class RoomsController < ApplicationController
  before_action :set_room, only: [:show, :edit, :update, :destroy]

  # GET /rooms
  # GET /rooms.json
  def index
    @rooms = Room.all
  end

  # GET /rooms/1
  # GET /rooms/1.json
  def show
  end

  # GET /rooms/new
  def new
    @room = Room.new
  end

  # GET /rooms/1/edit
  def edit
  end

  # POST /rooms
  # POST /rooms.json
  def create
    @room = Room.new(room_params)

    respond_to do |format|
      if @room.save
        format.html { redirect_to @room, notice: 'Room was successfully created.' }
        format.json { render :show, status: :created, location: @room }
      else
        format.html { render :new }
        format.json { render json: @room.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /rooms/1
  # PATCH/PUT /rooms/1.json
  def update
    respond_to do |format|
      if @room.update(room_params)
        format.html { redirect_to @room, notice: 'Room was successfully updated.' }
        format.json { render :show, status: :ok, location: @room }
      else
        format.html { render :edit }
        format.json { render json: @room.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /rooms/1
  # DELETE /rooms/1.json
  def destroy
    @room.destroy
    respond_to do |format|
      format.html { redirect_to rooms_url, notice: 'Room was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_room
      @room = Room.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def room_params
      params.require(:room).permit(:name, :description)
    end
end

app/helpers/rooms_helper.rb
module RoomsHelper
end

app/views/rooms/_form.html.erb
<%= form_for(@room) do |f| %>
  <% if @room.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@room.errors.count, "error") %> prohibited this room from being saved:</h2>

      <ul>
      <% @room.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_field :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/rooms/edit.html.erb
<h1>Editing room</h1>

<%= render 'form' %>

<%= link_to 'Show', @room %> |
<%= link_to 'Back', rooms_path %>

app/views/rooms/index.html.erb
<h3>Listing rooms</h3>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Description</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @rooms.each do |room| %>
      <tr>
        <td><%= room.name %></td>
        <td><%= room.description %></td>
        <td><%= link_to 'Show', room %></td>
        <td><%= link_to 'Edit', edit_room_path(room) %></td>
        <td><%= link_to 'Destroy', room, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Room', new_room_path %>

app/views/rooms/new.html.erb
<h1>New room</h1>

<%= render 'form' %>

<%= link_to 'Back', rooms_path %>

app/views/rooms/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @room.name %>
</p>

<p>
  <strong>Description:</strong>
  <%= @room.description %>
</p>

<%= link_to 'Edit', edit_room_path(@room) %> |
<%= link_to 'Back', rooms_path %>